var $ = jQuery;
$(function() {

    $("div.GroupContainerAttached").show().each(function() {
        $(this).css("height", $(this).height());
    });


    var jStudentInput = $(".InputStudentName").first(); 
    var jGradeSelect = $(".SelectGrade").first(); 
    var jSGSelect = $(".SelectStudyGroup").first(); 
    var jSearchResult = $(".SearchResult").first(); 

    var jStudentPrototype = $($.parseHTML(	"<div id='0' class='Student'>\
                                                <span class='Name'></span> \
                                                <span id='0' class='From'></span> \
                                                <button class='action'></button> \
                                            </div>"));

    var jGroupWrapPrototype = 	$($.parseHTML(	"<select class='SelectStudyGroup default_select'>\
                								<option value='0'>Выберите группу:</option>"));


    var jGroupPrototype = $($.parseHTML("<option value='0'></option>"));


    function ConstructGroup(groupID, groupNum, specName) {
    	var jClone = jGroupPrototype.clone();
    	var str = "группа "+groupNum
    	if (specName != null) {
    		str += " - "+specName; 
    	}
    	jClone.html(str);
    	jClone.val(groupID);
    	return jClone;
    }

    function ConstructStudent(ID, name, from, groupID, bind) {
        var jStudent = jStudentPrototype.clone();
        var jStudentSib = jStudent.children();

        if (bind === true) {
            var status = "StatusBind";
            var actionDesc = "Отсоединить студента";
            var action = "Action_UnbindStudent";
        } else { 
            var status = "StatusUnbind";
            var actionDesc = "Прикрепить студента";
            var action = "Action_BindStudent";
        }

        jStudent.attr("id", ID);
        jStudent.addClass(status+" "+groupID);
        jStudentSib.filter("span.Name").html(name);
        jStudentSib.filter("span.From").attr("id",groupID).html(from);
        jStudentSib.filter("button.action").addClass(action).html(actionDesc);
        
        return jStudent;
    }




    function SearchStudents() 
    {
        var name = [];
        var temp = $(".InputStudentName").val();
        if ( temp.length > 0)
            name = temp.split(" ");
        
        $.post(
            g_URLdir + "handler/map/SearchStudents",
            {
                "GradeID": jGradeSelect.val(),
                "GroupN": jSGSelect.val(),
                "FacultyID": g_facultyID,
                "Last": name[0],
                "First": name[1],
                "Second": name[2],
                "DisciplineID": g_disciplineID
            },
            function(searchResult){
                var searchResult = $.parseJSON(searchResult);
                var i = 0;
                jSearchResult.html("");
                var jClone = jSearchResult.clone();
                
                for(i in searchResult) {
                    var ID = searchResult[i].ID;
                    var name = searchResult[i].LastName +" "+  searchResult[i].FirstName +" "+ searchResult[i].SecondName;
                    var from = "курс " + searchResult[i].GradeNum + ", группа " + searchResult[i].GroupNum;
                    var groupID = searchResult[i].GroupID;
                    jClone.append(ConstructStudent(ID, name, from, groupID, false));
                }

                if (i <= 0) {
                    jSearchResult.html("<p class='notification'>Нет результатов... Возможно, студенты, соответствующие критериям поиска, уже прикреплены.</p>");
                } else {
                    jSearchResult.replaceWith(jClone);
                    jSearchResult = jClone;
                } 
            }
        ); //!post 
    }

    $(".SelectStudyGroup").change(function(){
        SearchStudents();
    });
    $(".InputStudentName").focusout(function(){
        SearchStudents();
    });
    $(".InputStudentName").keydown(function(e){
        if(e.keyCode==13){
            SearchStudents();
            $(this).blur();
        }
    });




    function GetStudyGroups() {
        $.post(
            g_URLdir + "handler/map/GetStudyGroups",
            {
                "FacultyID": g_facultyID,
                "GradeID": jGradeSelect.val()
            },
            function(data) {
                var i = 0;
                data = $.parseJSON(data);
                jSGSelect.html("");

                if (data != null && data != undefined) {
                    var jClone = jGroupWrapPrototype.clone(); 

                    for (i in data) {
                    	var temp = data[i];
                    	jClone.append(ConstructGroup(temp.GroupID, temp.GroupNum, temp.SpecName));
                    } 
                       
                    jSGSelect.replaceWith(jClone);
                    jSGSelect = jClone;
                }
                SearchStudents();
            } //!callback
        ); //!post      
    }

    $(".SelectGrade").change(function(){
        GetStudyGroups();
    });




    // Если студент из поиска
    function BindStudentFromSearch(jThis) 
    {
        var reg = /GroupID_\d+/;
        var GroupID = ""+reg.exec(jThis.parent().attr("class"));
        var ID = jThis.parent().attr("id");
        var Name = jThis.siblings(".Name").text();
        var From = jThis.siblings(".From").text();
        if ($("div").is(".GroupContainer."+GroupID) === false) {
            $(".AttachedStudentsList").append("\
                <div class='GradeAndGroupTitle ActionShowHideGroupContainer'>\
                <span class='info'>"+From+"</span>\
                <span class='Action'>Открыть список ▼</span>\
            </div>");
            $(".AttachedStudentsList").append("<div class='GroupContainer "+GroupID+"' style='display: block'> </div>");
        }
        $(".GroupContainer."+GroupID).append(ConstructStudent(ID, Name, From, GroupID, true));
        jThis.parent().remove();
    }

    // Если студент из основного потока
    function BindBackStudent(jThis) {
        jThis
            .removeClass("Action_BindStudent")
            .addClass("Action_UnbindStudent")
            .text("Отсоединить студента");
        jThis
            .parent()
            .removeClass("StatusUnbind")
            .addClass("StatusBind");
    }





    // Прикрепить студента 
    $(".StudentsList").on("click", "button.Action_BindStudent", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/BindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    BindBackStudent(jThis);
                }
                else EventInspector_ShowMsg("Ошибка при добавление студента", "error");
                jThis.removeAttr("disabled");
            }
        );
    });

    // Прикрепить студента из поиска
    $(".StudentsList").on("click", "button.Action_BindStudentFromSearch", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/BindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    BindStudentFromSearch(jThis);
                    //jThis.remove();
                }
                else EventInspector_ShowMsg("Ошибка при добавление студента", "error");
                jThis.removeAttr("disabled");
            }
        );
    });

    // Отсоединить студента 
    $(".StudentsList").on("click", "button.Action_UnbindStudent", function(){
        var jThis = $(this);
        $(this).attr("disabled", true);
        var ID = $(this).parent().attr("id");
        $.post(
            URLdir + "handler/map/UnbindStudent",
            {
                "StudentID": ID,
                "DisciplineID": g_disciplineID
            },
            function(data){
                data = $.parseJSON(data);
                if(data.success === true) {
                    jThis
                        .removeClass("Action_UnbindStudent")
                        .addClass("Action_BindStudent")
                        .text("Прикрепить студента");
                    jThis
                        .parent()
                        .removeClass("StatusBind")
                        .addClass("StatusUnbind");
                    EventInspector_ShowMsg("Студент отсоединен", "success");
                }
                else EventInspector_ShowMsg("Ошибка при отсоединение студента", "error");
                jThis.removeAttr("disabled");
            }
        );
    });

    // Показать/скрыть список студентов
    $(".StudentsList").on("click", ".ActionShowHideGroupContainer", function(){
        var GroupContainer = $(this).next(".GroupContainer");
        if (GroupContainer.css("display") == "none") {
            $(this).children(".Action").text("Скрыть список ▲");
            GroupContainer.show();
            GroupContainer.css("height", GroupContainer.height());
        }
        else {
            $(this).children(".Action").text("Открыть список ▼");
            GroupContainer.hide("normal");
        }
    });

    $(".StudentsList").on("click", "div.hideListAction", function(){
        $(this).parent()
            .hide("normal");
            
        $(this).parent()
            .prev()
            .children(".Action")
            .text("Открыть список ▼");
    });



});